package com.greenorange.promotion.model.vo.user;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;

/**
 * 用户表 视图对象
 */
@Data
@Schema(description = "用户表 视图对象")
public class UserInfoVO implements Serializable {

    /**
     * 用户表 ID
     */
    @Schema(description = "用户表 ID", example = "1")
    private Long id;

    /**
     * 用户昵称
     */
    @Schema(description = "用户昵称", example = "${field.example}")
    private String nickName;

    /**
     * 用户头像URL
     */
    @Schema(description = "用户头像URL", example = "${field.example}")
    private String userAvatar;

    /**
     * 手机号
     */
    @Schema(description = "手机号", example = "${field.example}")
    private String phoneNumber;

    /**
     * 密码（建议加密存储）
     */
    @Schema(description = "密码（建议加密存储）", example = "${field.example}")
    private String userPassword;

    /**
     * 邀请码
     */
    @Schema(description = "邀请码", example = "${field.example}")
    private String invitationCode;

    /**
     * 用户角色
     */
    @Schema(description = "用户角色", example = "${field.example}")
    private String userRole;

    /**
     * 上级用户id
     */
    @Schema(description = "上级用户id", example = "${field.example}")
    private Long parentUserId;

    /**
     * 上级用户列表（1,2,3）
     */
    @Schema(description = "上级用户列表（1,2,3）", example = "${field.example}")
    private String superUserList;


    @Serial
    private static final long serialVersionUID = 1L;
}
